#include <stdio.h>
#include <wav.h>

int
main(int argc, char *argv[])
{
	int i;
	FILE *f;
	wavFormatInfo *fi;
	wavStorage *st;

	for(i = 1; i < argc; i++) {
		if((f = fopen(argv[i], "r")) == NULL) {
			fprintf(stderr,
			    "%s: No such file or directory\n", argv[i]);
			continue;
		}
		if((st = readWavFile(f)) == NULL) {
			fprintf(stderr, "%s: failed to read file\n",
			    argv[i]);
			continue;
		}
		fi = (wavFormatInfo *)&st->info;
		printf("%s:\n", argv[i]);
		printf("\tFormat: %d\n", fi->formatid);
		printf("\tNumber of channels: %d\n", fi->nchannel);
		printf("\tSampling rate: %u\n", fi->samplerate);
		printf("\tData rate: %u\n", fi->datarate);
		printf("\tBlock size: %d\n", fi->blocksize);
		printf("\tBits per sample: %d\n", fi->samplebit);
		freeWavStorage(st);
		fclose(f);
	}
	return 0;
}

