#include <sys/types.h>
#include <xmmintrin.h>

#define rdtsc(t) asm volatile("rdtsc" : "=A" (t))

typedef struct {
	char ids[4];
	uint32_t len;
	char fmt[4];
} riffHeader;

typedef struct {
	char ids[4];
	uint32_t len;
} riffChunkHeader;

typedef struct {
	uint16_t formatid;
	uint16_t nchannel;
	uint32_t samplerate;
	uint32_t datarate;
	uint16_t blocksize;
	uint16_t samplebit;
} __attribute__ ((packed)) wavFormatInfo;

typedef struct {
		uint64_t infolen;
		uint64_t datalen;
		wavFormatInfo info;
		uint8_t data[0];
}  __attribute__ ((packed)) wavStorage;

int16_t addsw(int16_t x, int16_t y);
int16_t subsw(int16_t x, int16_t y);
int readRiffHeader(FILE *f, riffHeader *hdr);
int readChunkHeader(FILE *f, riffChunkHeader *chunk);
wavStorage *expandWavData(wavStorage *p, uint32_t align);
wavStorage *readWavFile(FILE *f);
void freeWavStorage(wavStorage *p);
int writeWavFile(wavStorage *p, FILE *f);

