#include <stdio.h>
#include "libcom.h"

void
usage(char *p)
{

    fprintf(stderr, "usage: %s\n", p);
}

int
main(int argc, char *argv[])
{
    operand		   *dst;

/*
 *	check if 0 command line argument is given
 */
    if(argc != 1) {
	usage(argv[0]);
	return -1;
    }

/*
 *	initialize memory chunk
 */
    if((dst = alloc_operand128(16, OPERAND_ALIGNED)) == NULL) {
	fprintf(stderr, "cannot allocate memory.\n");
	return -1;
    }

/*
 *	do the calculation with using SIMD instruction
 */
    asm volatile(
	"pxor	%%xmm0,	%%xmm0\n\t"
	"movdqa	%%xmm0,	(%0)\n"
	:
	:   "r"(dst->aligned)
	:   "%xmm0"
    );

/*
 *	show the result
 */
    printf("     result: %s\n", operand2str(dst));

/*
 *	do the calculation with using SIMD instruction
 */
    asm volatile(
	"pcmpeqb	%%xmm0,	%%xmm0\n\t"
	"movdqa	%%xmm0,	(%0)\n"
	:
	:   "r"(dst->aligned)
	:   "%xmm0"
    );

/*
 *	show the result
 */
    printf("     result: %s\n", operand2str(dst));

    free_operand(dst);

    return 0;
}

