#include <limits.h>
#include <stdlib.h>
#include <stdio.h>
#include "libcom.h"

void
usage(char *p)
{

    fprintf(stderr, "usage: %s [arg1]\n", p);
}

int
main(int argc, char *argv[])
{
    uint32_t		    src, dst;

/*
 *	check if 1 command line argument is given
 */
    if(argc != 2) {
	usage(argv[0]);
	return -1;
    }

/*
 *	convert each command line argument to packed value
 */
    src = strtoul(argv[1], NULL, 16);

/*
 *	show the contents of operands
 */
    printf("MOVNTI\n     source: %02x\n", src);

/*
 *	do the calculation with using SIMD instruction
 */
    asm volatile(
	"movl	(%0),	%%eax\n\t"
	"movnti	%%eax,	(%1)\n"
	:
	:   "r"(&src), "r"(&dst)
	:   "%eax"
    );

/*
 *	show the result
 */
    printf("     result: %02x\n", dst);

    return 0;
}

