#include <stdio.h>
#include "libcom.h"

void
usage(char *p)
{

    fprintf(stderr, "usage: %s [arg1]\n", p);
}

int
main(int argc, char *argv[])
{
    operand		   *src0, *dst0, *dst1, *dst2, *dst3,
			   *dst4, *dst5, *dst6, *dst7, *dst8;

/*
 *	check if 1 command line argument is given
 */
    if(argc != 2) {
	usage(argv[0]);
	return -1;
    }

/*
 *	convert each command line argument to packed value
 */
    if((src0 = hex2operand128(argv[1], 16, OPERAND_ALIGNED)) == NULL) {
	fprintf(stderr, "arg2(%s): invalid value.\n", argv[2]);
	return -1;
    }
    if((dst0 = alloc_operand128(16, OPERAND_ALIGNED)) == NULL) {
	fprintf(stderr, "cannot allocate memory.\n");
	return -1;
    }
    if((dst1 = alloc_operand128(16, OPERAND_ALIGNED)) == NULL) {
	fprintf(stderr, "cannot allocate memory.\n");
	return -1;
    }
    if((dst2 = alloc_operand128(16, OPERAND_ALIGNED)) == NULL) {
	fprintf(stderr, "cannot allocate memory.\n");
	return -1;
    }
    if((dst3 = alloc_operand128(16, OPERAND_ALIGNED)) == NULL) {
	fprintf(stderr, "cannot allocate memory.\n");
	return -1;
    }
    if((dst4 = alloc_operand128(16, OPERAND_ALIGNED)) == NULL) {
	fprintf(stderr, "cannot allocate memory.\n");
	return -1;
    }
    if((dst5 = alloc_operand128(16, OPERAND_ALIGNED)) == NULL) {
	fprintf(stderr, "cannot allocate memory.\n");
	return -1;
    }
    if((dst6 = alloc_operand128(16, OPERAND_ALIGNED)) == NULL) {
	fprintf(stderr, "cannot allocate memory.\n");
	return -1;
    }
    if((dst7 = alloc_operand128(16, OPERAND_ALIGNED)) == NULL) {
	fprintf(stderr, "cannot allocate memory.\n");
	return -1;
    }
    if((dst8 = alloc_operand128(16, OPERAND_ALIGNED)) == NULL) {
	fprintf(stderr, "cannot allocate memory.\n");
	return -1;
    }

/*
 *	show the contents of operands
 */
    printf("PSLLDQ\ndestination: %s\n", operand2str(src0));

/*
 *	do the calculation with using SIMD instruction
 */
    asm volatile(
	"movdqa	(%0),	%%xmm0\n\t"
	"pslldq	$0,	%%xmm0\n\t"
	"movdqa	%%xmm0,	(%1)\n"
	:
	:   "r"(src0->aligned), "r"(dst0->aligned)
	:   "%xmm0"
    );

/*
 *	show the result
 */
    printf("     result: %s\n", operand2str(dst0));

    free_operand(dst0);

/*
 *	do the calculation with using SIMD instruction
 */
    asm volatile(
	"movdqa	(%0),	%%xmm0\n\t"
	"pslldq	$2,	%%xmm0\n\t"
	"movdqa	%%xmm0,	(%1)\n"
	:
	:   "r"(src0->aligned), "r"(dst1->aligned)
	:   "%xmm0"
    );

/*
 *	show the result
 */
    printf("     result: %s\n", operand2str(dst1));

    free_operand(dst1);

/*
 *	do the calculation with using SIMD instruction
 */
    asm volatile(
	"movdqa	(%0),	%%xmm0\n\t"
	"pslldq	$4,	%%xmm0\n\t"
	"movdqa	%%xmm0,	(%1)\n"
	:
	:   "r"(src0->aligned), "r"(dst2->aligned)
	:   "%xmm0"
    );

/*
 *	show the result
 */
    printf("     result: %s\n", operand2str(dst2));

    free_operand(dst2);

/*
 *	do the calculation with using SIMD instruction
 */
    asm volatile(
	"movdqa	(%0),	%%xmm0\n\t"
	"pslldq	$6,	%%xmm0\n\t"
	"movdqa	%%xmm0,	(%1)\n"
	:
	:   "r"(src0->aligned), "r"(dst3->aligned)
	:   "%xmm0"
    );

/*
 *	show the result
 */
    printf("     result: %s\n", operand2str(dst3));

    free_operand(dst3);

/*
 *	do the calculation with using SIMD instruction
 */
    asm volatile(
	"movdqa	(%0),	%%xmm0\n\t"
	"pslldq	$8,	%%xmm0\n\t"
	"movdqa	%%xmm0,	(%1)\n"
	:
	:   "r"(src0->aligned), "r"(dst4->aligned)
	:   "%xmm0"
    );

/*
 *	show the result
 */
    printf("     result: %s\n", operand2str(dst4));

    free_operand(dst4);

/*
 *	do the calculation with using SIMD instruction
 */
    asm volatile(
	"movdqa	(%0),	%%xmm0\n\t"
	"pslldq	$10,	%%xmm0\n\t"
	"movdqa	%%xmm0,	(%1)\n"
	:
	:   "r"(src0->aligned), "r"(dst5->aligned)
	:   "%xmm0"
    );

/*
 *	show the result
 */
    printf("     result: %s\n", operand2str(dst5));

    free_operand(dst5);

/*
 *	do the calculation with using SIMD instruction
 */
    asm volatile(
	"movdqa	(%0),	%%xmm0\n\t"
	"pslldq	$12,	%%xmm0\n\t"
	"movdqa	%%xmm0,	(%1)\n"
	:
	:   "r"(src0->aligned), "r"(dst6->aligned)
	:   "%xmm0"
    );

/*
 *	show the result
 */
    printf("     result: %s\n", operand2str(dst6));

    free_operand(dst6);

/*
 *	do the calculation with using SIMD instruction
 */
    asm volatile(
	"movdqa	(%0),	%%xmm0\n\t"
	"pslldq	$14,	%%xmm0\n\t"
	"movdqa	%%xmm0,	(%1)\n"
	:
	:   "r"(src0->aligned), "r"(dst7->aligned)
	:   "%xmm0"
    );

/*
 *	show the result
 */
    printf("     result: %s\n", operand2str(dst7));

    free_operand(dst7);

/*
 *	do the calculation with using SIMD instruction
 */
    asm volatile(
	"movdqa	(%0),	%%xmm0\n\t"
	"pslldq	$16,	%%xmm0\n\t"
	"movdqa	%%xmm0,	(%1)\n"
	:
	:   "r"(src0->aligned), "r"(dst8->aligned)
	:   "%xmm0"
    );

/*
 *	show the result
 */
    printf("     result: %s\n", operand2str(dst8));

    free_operand(dst8);

    return 0;
}

